/*
 *  brisk - dom-drag.js
 *
 *  Copyright (C) 2006-2011 Matteo Nastasi
 *                          mailto: nastasi@alternativeoutput.it 
 *                                  matteo.nastasi@milug.org
 *                          web: http://www.alternativeoutput.it
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABLILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details. You should have received a
 * copy of the GNU General Public License along with this program; if
 * not, write to the Free Software Foundation, Inc, 59 Temple Place -
 * Suite 330, Boston, MA 02111-1307, USA.
 *
 */

/**************************************************
 * dom-drag.js
 * 09.25.2001
 * www.youngpup.net
 **************************************************
 * 10.28.2001 - fixed minor bug where events
 * sometimes fired off the handle, not the root.
 **************************************************/

function Drag(mouseup_cb, minX, maxX, minY, maxY, bSwapHorzRef, bSwapVertRef, fXMapper, fYMapper)
{
    console.log("xx"+this);
    this.onmousedown   = Drag.prototype.start;
    this.mouseup_cb    = mouseup_cb;
    this.connect       = function(conn)
    {
        this.parentNode.connected[this.parentNode.connected.length] = conn;
    }
    
    this.connected     = new Array();
    /*  		alert("agnulla"+this.style.left); */
    
    this.hmode			= bSwapHorzRef ? false : true ;
    this.vmode			= bSwapVertRef ? false : true ;
    
    this.root = this.xynt_dom_el && this.xynt_dom_el != null ? this.xynt_dom_el : this ;
    
    if (this.hmode && isNaN(parseInt(this.root.style.left  ))) {
        var res = parseInt(getStyle(o, "left", "left"));
		    if (isNaN(res)) {
			this.root.style.left   = "0px";
		    }
	else {
	    this.root.style.left   = res;
	}
    }
    if (this.vmode  && isNaN(parseInt(this.root.style.top   ))) {
        var res = parseInt(getStyle(o, "top", "top"));
	if (isNaN(res)) {
	    this.root.style.top   = "0px";
	}
	else {
	    this.root.style.top   = res;
	}
    }
    if (!this.hmode && isNaN(parseInt(this.root.style.right ))) this.root.style.right  = "0px";
    if (!this.vmode && isNaN(parseInt(this.root.style.bottom))) this.root.style.bottom = "0px";
    
    this.minX	= typeof minX != 'undefined' ? minX : null;
    this.minY	= typeof minY != 'undefined' ? minY : null;
    this.maxX	= typeof maxX != 'undefined' ? maxX : null;
    this.maxY	= typeof maxY != 'undefined' ? maxY : null;
    
    this.xMapper = fXMapper ? fXMapper : null;
    this.yMapper = fYMapper ? fYMapper : null;
    
    this.root.onDragStart	= new Function();
    this.root.onDragEnd	= new Function();
    this.root.onDrag		= new Function();
}

Drag.prototype = {

	obj : null,

	start : function(e)
	{
            console.log("Drag.start");
		var o = Drag.obj = this;
		e = Drag.prototype.fixE(e);

               if (!e) 
                   var e = window.event
	       // handle event
	       e.cancelBubble = true;
	       if (e.stopPropagation) 
                   e.stopPropagation();

	        o.oldzidx = o.style.zIndex;
		o.style.zIndex = 10;

		// alert("start");

		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		o.root.onDragStart(x, y);

		o.lastMouseX	= e.clientX;
		o.lastMouseY	= e.clientY;

		if (o.hmode) {
			if (o.minX != null)	o.minMouseX	= e.clientX - x + o.minX;
			if (o.maxX != null)	o.maxMouseX	= o.minMouseX + o.maxX - o.minX;
		} else {
			if (o.minX != null) o.maxMouseX = -o.minX + e.clientX + x;
			if (o.maxX != null) o.minMouseX = -o.maxX + e.clientX + x;
		}

		if (o.vmode) {
			if (o.minY != null)	o.minMouseY	= e.clientY - y + o.minY;
			if (o.maxY != null)	o.maxMouseY	= o.minMouseY + o.maxY - o.minY;
		} else {
			if (o.minY != null) o.maxMouseY = -o.minY + e.clientY + y;
			if (o.maxY != null) o.minMouseY = -o.maxY + e.clientY + y;
		}

		document.onmousemove	= Drag.prototype.drag;
		document.onmouseup	= Drag.prototype.end;

            for(var i = 0 ; i < o.connected.length ; i++) {
                o.connected[i].update('start', o);
            }

		return false;
	},

	drag : function(e)
	{
		e = Drag.prototype.fixE(e);
		var o = Drag.obj;

		var ey	= e.clientY;
		var ex	= e.clientX;
		var y = parseInt(o.vmode ? o.root.style.top  : o.root.style.bottom);
		var x = parseInt(o.hmode ? o.root.style.left : o.root.style.right );
		var nx, ny;

		if (o.minX != null) ex = o.hmode ? Math.max(ex, o.minMouseX) : Math.min(ex, o.maxMouseX);
		if (o.maxX != null) ex = o.hmode ? Math.min(ex, o.maxMouseX) : Math.max(ex, o.minMouseX);
		if (o.minY != null) ey = o.vmode ? Math.max(ey, o.minMouseY) : Math.min(ey, o.maxMouseY);
		if (o.maxY != null) ey = o.vmode ? Math.min(ey, o.maxMouseY) : Math.max(ey, o.minMouseY);

		nx = x + ((ex - o.lastMouseX) * (o.hmode ? 1 : -1));
		ny = y + ((ey - o.lastMouseY) * (o.vmode ? 1 : -1));

		if (o.xMapper)		nx = o.xMapper(y)
		else if (o.yMapper)	ny = o.yMapper(x)

		Drag.obj.root.style[o.hmode ? "left" : "right"] = nx + "px";
		Drag.obj.root.style[o.vmode ? "top" : "bottom"] = ny + "px";
		Drag.obj.lastMouseX	= ex;
		Drag.obj.lastMouseY	= ey;

		Drag.obj.root.onDrag(nx, ny);

            for(var i = 0 ; i < o.connected.length ; i++) {
                o.connected[i].update('drag', o);
            }

		return false;
	},

	end : function(e)
	{
		e = Drag.prototype.fixE(e);
		var o = Drag.obj;

		o.style.zIndex = o.oldzidx;
		// alert("END");
		if (o.mouseup_cb != null) {
		    if (o.mouseup_cb(o) == 1) {
			o.onmousedown = null;
		    }
		}

		document.onmousemove = null;
		document.onmouseup   = null;
		Drag.obj.root.onDragEnd(	parseInt(Drag.obj.root.style[Drag.obj.hmode ? "left" : "right"]), 
									parseInt(Drag.obj.root.style[Drag.obj.vmode ? "top" : "bottom"]));
            for(var i = 0 ; i < o.connected.length ; i++) {
                o.connected[i].update('end', o);
            }

		Drag.obj = null;
	},

	fixE : function(e)
	{
		if (typeof e == 'undefined') e = window.event;
		if (typeof e.layerX == 'undefined') e.layerX = e.offsetX;
		if (typeof e.layerY == 'undefined') e.layerY = e.offsetY;
		return e;
	}
};
